require 'stringio'
require 'shellwords'

module Lucent
  class Tester
    include Shellwords

    def self.app_class=(name)
      @@app_class = name
    end

    def initialize(command)
      args = shellwords(command)
      @argv = args[1..-1]
      @stdin = StringIO.new
      @stdout = StringIO.new
      @stderr = StringIO.new
      @kernel = MockKernel.new
    end

    def run
      @@app_class.new(@argv, @stdin, @stdout, @stderr, @kernel).start
    end

    def stop
      @kernel.exitstatus
    end

    def stdout
      @stdout.string
    end

    def stderr
      @stderr.string
    end

    class MockKernel
      attr_reader :exitstatus

      def initialize
        @exitstatus = 0
      end

      def exit(status)
        @exitstatus = status
      end
    end

  end
end